﻿#!/bin/bash
#author of work: Cointopay
#date 11-10-2014 update: 17-01-2015
#version 0.1
#should work on debian wheezy and ubuntu 14.04 and higher
#execute as root due to the paste is sudoers file

#update 0.2: if bitcoin then take an alternative path

alternative="no"
blocksync="no"

if [ $# -eq 0 ]
  then
    echo "Use this script in conjunction with the Cointopay service"
    echo "This is a fire and forget type of script"
    echo "Cointopay.com - support@cointopay.com"
    echo "Script will print out necessary items for Cointopay service"
    echo ""
    echo "Cointopay deployer expects 4 arguments/parameters (2 optional):"
    echo "1 user to create"
    echo "2 password for user"
    echo "3 name of coin e.g. peercoin all lowercase!"
    echo "4 github address e.g. https://github.com/ppcoin/ppcoin"
    echo ""
    echo "5 optional: include blockchain sync as part of script"
    echo "6 optional: include alternative compile method e.g. bitcoin"
    echo ""
    echo "This script will print out the command you need to run"
    echo "to start your wallet.. if you want to capture it do: > log.txt"
    echo "The print out includes rpc user and password"
    echo "secure url and port number"
    echo ""
    echo "P.S. Script must be run under root (not sudo root)"
    echo "start wallet preferably under username that was created in script"
exit
fi

if [ $# -eq 1 ]
  then
    echo "Not enough arguments, run script without arguments to get arguments"
exit
fi

if [ $# -eq 2 ]
  then
    echo "Not enough arguments, run script without arguments to get arguments"
exit
fi

if [ $# -eq 3 ]
  then
    echo "Not enough arguments, run script without arguments to get arguments"
exit
fi

if [ $# -eq 5 ]
  then
    echo "With four arguments we are assuming you want to include a blockchain sync"
    blocksync="yes"
fi

if [ $# -eq 6 ]
  then
    echo "With five arguments we are assuming you want to try the alternative approach to e.g. install bitcoin"
    alternative="yes"
fi

sudo useradd -m -p $2 $1
#sudo usermod -s /bin/bash $1

sudo apt-get -y update 
sudo apt-get -y upgrade
#autoconf libtool pkg-config are part of alternative approach
sudo apt-get -y install nano git build-essential autoconf libtool pkg-config
sudo libtoolize
sudo apt-get -y install qt4-qmake libqt4-dev libboost-dev libboost-system-dev libboost-filesystem-dev libboost-program-options-dev libboost-thread-dev libssl-dev
sudo apt-get -y install libdb5.1++-dev ; sudo apt-get install libminiupnpc-dev
sudo apt-get -y install libssl-dev libdb++-dev libboost-all-dev libqrencode-dev libboost-all-dev aptitude ; sudo aptitude search boost
sudo apt-get -y update 
sudo apt-get -y upgrade
sudo dd if=/dev/zero of=/swapfile bs=1024 count=524288
sudo mkswap /swapfile ; sudo chown root:root /swapfile ; sudo chmod 0600 /swapfile
sudo swapon /swapfile
sudo echo "/swapfile swap swap defaults 0 0" >> /etc/fstab
sudo echo "$1 ALL=(ALL)NOPASSWD:ALL"  >> /etc/sudoers
sudo mkdir /mnt/sda1
sudo chown $1:$1 /mnt/sda1
sudo mkdir /mnt/sda1/$3
sudo chown $1:$1 /mnt/sda1/$3
sudo '' > /mnt/sda1/$3/$3.conf
sudo chown $1:$1 /mnt/sda1/$3/*
pass="`date | md5sum | sed -e 's/  -//'`"
port="`echo 31373`"
sudo echo "#add this piece but modify the username and password
rpcuser=$3
rpcpassword=${pass}
rpcport=${port}
#below is our app server you will receive connections from, we will add more as our service grows.
#Check if your firewall is open for negotiumrpc
rpcallowip=54.72.85.108
rpcallowip=45.32.239.54
rpcssl=1
rpcsslcertificatechainfile=server.cert
rpcsslprivatekeyfile=server.pem
rpcsslciphers=DEFAULT:@STRENGTH
datadir=/mnt/sda1/$3" >> /mnt/sda1/$3/$3.conf
cd /mnt/sda1/$3
openssl genrsa -out server.pem 2048 ; openssl req -new -x509 -nodes -sha1 -days 3650 -subj "/C=NL/ST=NH/L=Haarlem/O=Cointopay/OU=Cointopay/CN=Cointopay.com/emailAddress=support@cointopay.com" -key server.pem > server.cert
sudo chown $1:$1 /mnt/sda1/$3/*
cd /mnt/sda1/$3/
git clone $4 $3
cd $3
cd src
sudo chmod 755 leveldb/build_detect_platform

if [ "$alternative" == "no" ]; then
#normal
make -f makefile.unix USE_UPNP=-
fi

if [ "$alternative" == "yes" ]; then
#alternative
wget -O db-6.1.19.tar.gz http://download.oracle.com/berkeley-db/db-6.1.19.tar.gz
tar -xzvf db-6.1.19.tar.gz
cd db-6.1.19/build_unix
../dist/configure --enable-cxx CPPFLAGS="-I/usr/local/BerkeleyDB.6.1/include -O2" LDFLAGS="-L/usr/local/BerkeleyDB.6.1/lib"
make
make install

export BDB_INCLUDE_PATH="/usr/local/BerkeleyDB.6.1/include"
export BDB_LIB_PATH="/usr/local/BerkeleyDB.6.1/lib"
ln -s /usr/local/BerkeleyDB.6.1/lib/libdb-6.1.so /usr/lib/libdb-6.1.so
../dist/configure CPPFLAGS="-I/usr/local/BerkeleyDB.6.1/include -O2" LDFLAGS="-L/usr/local/BerkeleyDB.6.1/lib"
cd ../..
cd ../
./autogen.sh
./configure --with-incompatible-bdb --without-gui --enable-cxx
cd src
make
make install
fi

file1="`ls -Art | tail -n 1`"
echo "ALL DONE! With info:"
echo "Run this command to start your server, preferably under user:" $1
echo nohup ./${file1} -daemon -server=1 -conf=$3.conf -datadir=/mnt/sda1/$3 &
echo "Some RPC information:"
echo "rpcuser:" $3
echo "rpcpassword:" ${pass}
echo "rpcport:" ${port}
ipadd="`/sbin/ifconfig eth0 | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'`"
echo "Assumed ip address:" ${ipadd}
echo "This is your endpoint:" https://${ipadd}:${port}
echo "Issues and Questions: support@cointopay.com"
echo ""
echo "Changing directory to where daemon is compiled"
echo cd /mnt/sda1/$3/$3/src
cd /mnt/sda1/$3/$3/src

#Start blockchain syncing
if [ "$blocksync" == "yes" ]; then
echo "starting the sync with the blockchain"
nohup ./${file1} -daemon -server=1 -conf=$3.conf -datadir=/mnt/sda1/$3 &
fi
